This supplement contains all scripts necessary to repoduce figures in the accompanying text.

### Dependencies
The figures here were generated on a Linux system with Python 2.7, numpy 1.14.3, scipy 0.18.1, matplotlib 2.2.2, and pyexpander 1.5.0. If Python and pip are already installed, the other packages can be installed with pip:
```
pip install numpy==1.14.3 scipy==0.18.1 matplotlib==2.2.2 pyexpander==1.8.4
```

The geodynamic models were run with Aspect version 2.0.0-pre on git commit 9a2e0031d53747bf339ecd74fb510e947f89f58c.
The code can be downloaded with git:
```
git clone https://github.com/geodynamics/aspect.git
cd aspect
git checkout 9a2e0031d53747bf339ecd74fb510e947f89f58c
```
See the Aspect manual for build instructions.

-----
## Figure 1
Figure 1 is generated entirely within the mkfig1.py script. It was originally run with python 2.7, numpy version 1.14.3, and matplotlib version 2.2.2

```
python ./mkfig1.py
```

-----
## Figure 2
Figure 2 is just an svg cartoon, made in inkscape.

-----
## Figure 3 & 4
Figures 3 and 4 require an ensemble of Aspect models. Assuming the prerequisites listed above, they can be reproduced with:
```
cd Ensemble
make models
```
and the figures can then be generated with
```
./mkfig3_fig4.py
```

-----
## Figure A1
Figure A1 requires another suite of models with increasingly refined meshes. Assuming the prerequeisites listed at the top of this file, those models can be reproduced with:
```
cd Convergence
make models
```
And the figure its self can then be generated with
```
./mkfigA1.py
```

-----
## Figure A2
Figure A2 is based on a subset of the model ensemble used for Figure 3 and Figure 4. If those models have already been run, then Figure A2 can be generated with
```
./mkfigA2.py
```
