#!/usr/bin/env python
# -*- coding: utf-8 -*-

import pylab as pl

'''
The following long formulas are adapted from the matlab supplement to Lev & Hager, 2008.
'''

k = pl.array([0.05*1.1**n for n in range(70)])

tau_isotropic = (pl.exp(-2*k)*(2*k - pl.exp(2*k) + 2*k**2 + 1))/(4*k)

tau_horizontal = (pl.exp(k*(10**(0.5) + 3))*(1560*pl.exp(k*(10**(0.5) - 3)) \
        - 2640*pl.exp(k*(10**(0.5) + 3)) - 450*pl.exp(-3*k*(10**(0.5) - 1)) \
        + 1530*pl.exp(3*k*(10**(0.5) - 1)) + 1530*pl.exp(-3*k*(10**(0.5) + 1)) \
        - 450*pl.exp(3*k*(10**(0.5) + 1)) - 2640*pl.exp(-k*(10**(0.5) - 3)) + 1560*pl.exp(-k*(10**(0.5) + 3)) \
        - 910*pl.exp(k*(10**(0.5) - 9)) + 910*pl.exp(k*(10**(0.5) + 9)) + 910*pl.exp(-k*(10**(0.5) - 9)) - 910*pl.exp(-k*(10**(0.5) + 9)) \
        - 303*10**(0.5)*pl.exp(k*(10**(0.5) - 3)) - 723*10**(0.5)*pl.exp(k*(10**(0.5) + 3)) - 117*10**(0.5)*pl.exp(-3*k*(10**(0.5) - 1)) \
        + 477*10**(0.5)*pl.exp(3*k*(10**(0.5) - 1)) - 477*10**(0.5)*pl.exp(-3*k*(10**(0.5) + 1)) + 117*10**(0.5)*pl.exp(3*k*(10**(0.5) + 1)) \
        + 723*10**(0.5)*pl.exp(-k*(10**(0.5) - 3)) + 303*10**(0.5)*pl.exp(-k*(10**(0.5) + 3)) - 280*10**(0.5)*pl.exp(k*(10**(0.5) - 9)) \
        - 260*10**(0.5)*pl.exp(k*(10**(0.5) + 9)) + 260*10**(0.5)*pl.exp(-k*(10**(0.5) - 9)) + 280*10**(0.5)*pl.exp(-k*(10**(0.5) + 9))))\
        / (18*k*(11*pl.exp(-2*10**(0.5)*k) - 10*pl.exp(6*k) - 10*pl.exp(-6*k) + 11*pl.exp(2*10**(0.5)*k) - 2*10**(0.5)*pl.exp(-2*10**(0.5)*k) \
        + 2*10**(0.5)*pl.exp(2*10**(0.5)*k) + 2)*(7*pl.exp(6*k) - 13*pl.exp(2*10**(0.5)*k) + 7*pl.exp(2*k*(10**(0.5) + 3)) \
        - 4*10**(0.5)*pl.exp(2*10**(0.5)*k) + 4*10**(0.5) - 2*10**(0.5)*pl.exp(2*k*(10**(0.5) + 3)) + 2*10**(0.5)*pl.exp(6*k) - 13))

tau_dipping = ((k**8*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(33696./25. - 12672j/25.) \
        - pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*(33696./25. - 12672j/25))*(44./125 - 117j/125) \
        - k**8*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) - (k**2*(- 4./5. - 3j/5))**(0.5))*1440j \
        + k**8*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*1440j \
        + k**5*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. - 3j/5))**(3./2)*450j \
        + k**5*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(3./2)*450j \
        + k**7*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. - 3j/5))**(0.5)*(270 + 360j) \
        - k**7*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(270 - 360j) \
        + k**5*(k**2*(- 4./5. - 3j/5))**(1.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5))*450j - pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        + (k**2*(- 4./5. + 3j/5))**(0.5))*450j) - k**5*(k**2*(- 4./5. + 3j/5))**(1.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5))*450j + pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*450j) \
        + k**7*(k**2*(- 4./5. + 3j/5))**(0.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(432 + 126j) \
        + pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*(432 + 126j))*(44./125 - 117j/125) \
        - k**7*(k**2*(- 4./5. - 3j/5))**(0.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(6048./25 - 9486j/25) \
        - pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*(6048./25 - 9486j/25))*(44./125 - 117j/125) - k**5*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) \
        - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. - 3j/5))**(1.5)*450j + k**5*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) \
        - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*450j - k**7*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) \
        - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. - 3j/5))**(0.5)*(270 + 360j) - k**7*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) \
        - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(270 - 360j) + k**2*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) \
        - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*1250j - k**4*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) \
        - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(750 - 1000j) \
        + k**4*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(750 + 1000j) \
        + k**6*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*1250j \
        - k**2*pl.exp(-2*(k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(375 - 500j) \
        + k**2*pl.exp(-2*(k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(375 + 500j) \
        - k**4*pl.exp(-2*(k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(600 - 175j) \
        - k**4*pl.exp(-2*(k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(600 - 175j) \
        + k**4*pl.exp(-2*(k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(600 + 175j) \
        + k**4*pl.exp(-2*(k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(600 + 175j) \
        - k**6*pl.exp(-2*(k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(585 + 220j) \
        + k**6*pl.exp(-2*(k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(585 - 220j) \
        + k**2*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5))*1250j - pl.exp(2*(k**2*(- 4./5. - 3j/5))**(0.5))*(375 - 500j) + pl.exp(2*(k**2*(- 4./5. + 3j/5))**(0.5))*(375 + 500j) \
        + pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*1250j - 7000j) \
        - k**4*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5))*(750 - 1000j) + pl.exp(2*(k**2*(- 4./5. - 3j/5))**(0.5))*(600 - 175j) - pl.exp(2*(k**2*(- 4./5. + 3j/5))**(0.5))*(600 + 175j) \
        + pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*(750 - 1000j) - (3000 - 4700j)) \
        + k**4*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5))*(750 + 1000j) - pl.exp(2*(k**2*(- 4./5. - 3j/5))**(0.5))*(600 - 175j) + pl.exp(2*(k**2*(- 4./5. + 3j/5))**(0.5))*(600 + 175j) \
        + pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*(750 + 1000j) - (3000 + 4700j)) \
        - k**6*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5))*(1170 - 440j) + pl.exp(2*(k**2*(- 4./5. - 3j/5))**(0.5))*625j \
        - pl.exp(2*(k**2*(- 4./5. + 3j/5))**(0.5))*(10296./25 + 11753j/25) + pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        + (k**2*(- 4./5. + 3j/5))**(0.5))*(1170 - 440j) - (96408./25 - 36256j/25))*(44./125 - 117j/125) \
        + k**2*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*1250j \
        - k**4*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(750 - 1000j) \
        + k**4*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(750 + 1000j) \
        + k**6*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*1250j)*1j)/(3*((k**2*(- 4./5. - 3j/5))**(9./2)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5))*(8964./25 + 11052j/25) - pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*(8964./25 + 11052j/25)) \
        - (k**2*(- 4./5. + 3j/5))**(9./2)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(8964./25 - 11052j/25) + pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        + (k**2*(- 4./5. + 3j/5))**(0.5))*(8964./25 - 11052j/25)) - pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. - 3j/5))**(9./2)*(8964./25 \
        + 11052j/25) + pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(9./2)*(8964./25 - 11052j/25) - k**9*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5))*(9504./25 + 25272j/25) - pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*(9504./25 + 25272j/25))*(44./125 - 117j/125) - 1080*k**9*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) \
        - (k**2*(- 4./5. - 3j/5))**(0.5)) + pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. - 3j/5))**(9./2)*(8964./25 + 11052j/25) \
        + pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(9./2)*(8964./25 - 11052j/25) + 1080*k**9*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5)) + k**8*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. - 3j/5))**(0.5)*(324 - 468j) \
        + k**8*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(324 + 468j) \
        + k**8*(k**2*(- 4./5. + 3j/5))**(0.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(324 - 468j) \
        + pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*(324 - 468j))*(44./125 - 117j/125) + k**8*(k**2*(- 4./5. - 3j/5))**(0.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5))*(69012./125 + 17316j/125) - pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*(69012./125 + 17316j/125))*(44./125 - 117j/125) \
        - k**8*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. - 3j/5))**(0.5)*(324 - 468j) + k**8*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) \
        - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(324 + 468j) + 900*k**3*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(1.5) \
        + k**5*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(720 + 540j) + k**5*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) \
        - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(720 - 540j) + 900*k**7*pl.exp((k**2*(- 4./5. + 3j/5))**(0.5) \
        - (k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(0.5) + k**3*pl.exp(-2*(k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(300 + 225j) \
        + k**3*pl.exp(-2*(k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(300 - 225j) \
        + k**5*pl.exp(-2*(k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(105 + 360j) \
        + k**5*pl.exp(-2*(k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(105 + 360j) \
        + k**5*pl.exp(-2*(k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(105 - 360j) \
        + k**5*pl.exp(-2*(k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(105 - 360j) \
        - k**7*pl.exp(-2*(k**2*(- 4./5. - 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(132 - 351j) \
        - k**7*pl.exp(-2*(k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(132 + 351j) \
        + k**3*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(900*pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5)) \
        + pl.exp(2*(k**2*(- 4./5. - 3j/5))**(0.5))*(300 + 225j) + pl.exp(2*(k**2*(- 4./5. + 3j/5))**(0.5))*(300 - 225j) + 900*pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        + (k**2*(- 4./5. + 3j/5))**(0.5)) - 4200) + k**5*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5))*(720 + 540j) + pl.exp(2*(k**2*(- 4./5. - 3j/5))**(0.5))*(105 + 360j) + pl.exp(2*(k**2*(- 4./5. + 3j/5))**(0.5))*(105 - 360j) \
        + pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*(720 + 540j) - (2820 + 1800j)) + k**5*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5))*(720 - 540j) + pl.exp(2*(k**2*(- 4./5. - 3j/5))**(0.5))*(105 + 360j) + pl.exp(2*(k**2*(- 4./5. + 3j/5))**(0.5))*(105 - 360j) \
        + pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*(720 - 540j) - (2820 - 1800j)) + k**7*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) \
        - (k**2*(- 4./5. + 3j/5))**(0.5))*(1584./5. + 4212j/5) - 375*pl.exp(2*(k**2*(- 4./5. - 3j/5))**(0.5)) + pl.exp(2*(k**2*(- 4./5. + 3j/5))**(0.5))*(35259./125 - 30888j/125) \
        + pl.exp((k**2*(- 4./5. - 3j/5))**(0.5) + (k**2*(- 4./5. + 3j/5))**(0.5))*(1584./5. + 4212j/5) - (108768./125. + 289224j/125))*(44./125 - 117j/125) \
        + 900*k**3*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(1.5) \
        + k**5*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(1.5)*(720 + 540j) \
        + k**5*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(1.5)*(k**2*(- 4./5. - 3j/5))**(0.5)*(720 - 540j) \
        + 900*k**7*pl.exp(- (k**2*(- 4./5. - 3j/5))**(0.5) - (k**2*(- 4./5. + 3j/5))**(0.5))*(k**2*(- 4./5. + 3j/5))**(0.5)*(k**2*(- 4./5. - 3j/5))**(0.5)))
 

## Lev & Hager (2008) numerical results.
## Visually copied from Lev & Hager (2008), Fig. 2
levhager_iso = [[0.18,0.345,0.646,1.288,2.45,5.0], [29,16.2,12.04,12.12,14.85,22.5]]
levhager_dip = [[0.18,0.345,0.646,1.288,2.45,5.0], [23.96,13.6,9.21,7.42,9.4,15.25]]
levhager_hzt = [[0.18,0.345,0.646,1.288,2.45,5.0], [8.02,5.1,4.85,8.46,12.3,15.96]]

from tools import load_ensemble

ensemble = load_ensemble()

i_models = ensemble.get_models(lambda dim,dip,eta,k: eta==1.0)
h_models = ensemble.get_models(lambda dim,dip,eta,k: eta==0.1 and dip==00.0)
d_models = ensemble.get_models(lambda dim,dip,eta,k: eta==0.1 and dip==45.0)

ki = [m.k for m in i_models]
kh = [m.k for m in h_models]
kd = [m.k for m in d_models]

gi = [m.get_property_sequence('velocity[1]', lambda vy: pl.sqrt((vy**2)).max())[0] for m in i_models]
gh = [m.get_property_sequence('velocity[1]', lambda vy: pl.sqrt((vy**2)).max())[0] for m in h_models]
gd = [m.get_property_sequence('velocity[1]', lambda vy: pl.sqrt((vy**2)).max())[0] for m in d_models]

##
## Make Figure
##

pl.style.use('paper')
fig = pl.figure()
ax = fig.gca()

ax.plot(levhager_iso[0], levhager_iso[1], '-^', linewidth=0.5, markersize=3, color='#666666')
ax.plot(levhager_hzt[0], levhager_hzt[1], '-^', linewidth=0.5, markersize=3, color='#6666FF')
ax.plot(levhager_dip[0], levhager_dip[1], '-^', linewidth=0.5, markersize=3, color='#FF6666')

# Plot analytic solutions
ax.plot(k, -1./tau_isotropic, label='Isotropic', color='black')
ax.plot(k, -1./tau_horizontal, label='Horizontal', color='blue')
ax.plot(k, -1./pl.real(tau_dipping), label='Dipping', color='red')

if len(ki) > 0:
    #ax.scatter(ki, gi, label='Isotropic', color='#000000')
    ax.plot(ki, gi, '-o', linewidth=0., color='#000000')
if len(kh) > 0:
    #ax.scatter(kh, gh, label='Horizontal', color='#0000FF')
    ax.plot(kd, gh, '-o', linewidth=0., color='#0000FF')
if len(kd) > 0:
    #ax.scatter(kd, gd, label='Dipping', color='#FF0000')
    ax.plot(kd, gd, '-o', linewidth=0., color='#FF0000')

ax.set_xscale('log')
ax.set_yscale('log')
ax.set_xlim((0.15,6.5))
ax.set_ylim((4.5,128))

ax.set_xlabel('Wavenumber')
ax.set_ylabel('1/Growth rate')

black_patch = pl.matplotlib.patches.Patch(color='black', label='Isotropic  $(\\eta_S/\\eta_N = 1.0)$')
blue_patch = pl.matplotlib.patches.Patch(color='blue',   label='Horizontal $(\\eta_S/\\eta_N = 0.1)$')
red_patch = pl.matplotlib.patches.Patch(color='red',     label='Dipping    $(\\eta_S/\\eta_N = 0.1)$')
circles = pl.matplotlib.lines.Line2D([], [], color='black', marker='o', markersize=8, label='Model Results',linewidth=0)
triangles = pl.matplotlib.lines.Line2D([], [], color='black', marker='^', markersize=5, label='Lev & Hager (2008)',linewidth=0.5)
ax.legend(handles=[black_patch, blue_patch, red_patch,circles,triangles], loc='upper right')

pl.tight_layout()

fig.savefig('figA2.eps')
